function ml = linreg_t_GD(store_theta,y,X,prior)
[nsim, m] = size(store_theta);
T = size(X,1);
theta_hat = mean(store_theta)';
Qtheta = cov(store_theta);
alp = .05;     % significance level for truncation
chi2q = chi2inv(1-alp,m);
    % normalizing constant for f
const_f = log(1/(1-alp)) - m/2*log(2*pi) -.5*log(det(Qtheta)); 
store_w = - inf(nsim,1);
for isim = 1:nsim
    theta = store_theta(isim,:)';
    beta = theta(1:m-2);
    sig2 = theta(m-1);
    nu = theta(m);        
        
    if (theta-theta_hat)'*(Qtheta\(theta-theta_hat)) < chi2q   
        llike = T*(gammaln((nu+1)/2)-gammaln(nu/2)-.5*log(nu*pi*sig2))...
            - (nu+1)/2*sum(log(1 + (y-X*beta).^2/(sig2*nu)));
        f = @(th) const_f - .5*(th-theta_hat)'*(Qtheta\(th-theta_hat));
        store_w(isim) = f(theta) - (llike + prior(beta,sig2,nu));   
    end
end
maxllike = max(store_w);
ml = log(mean(exp(store_w-maxllike))) + maxllike;
ml = -ml;
end