% Newton-Raphson example
randn('seed',123456); rand('seed',123456);
T = 100;
nu = 5;
lam = 1./gamrnd(nu/2,2/nu,T,1);

T = size(lam,1);
sum1 = sum(log(lam));
sum2 = sum(1./lam);
df_nu = @(x) T/2*(log(x/2) + 1 - psi(x/2)) - .5*(sum1+sum2);
d2f_nu = @(x) T/(2*x) - T/4*psi(1,x/2);
S_nu = 1;
nut = 10;
while abs(S_nu) > 10^(-5)   % stopping criteria
    S_nu = df_nu(nut);
    H_nu = d2f_nu(nut); 
    nut = nut - H_nu\S_nu;
end
