% compute posterior mean
mu0 = 10; sig02 = 1;
ybar = 20; sig2 = 1;
n_grid = 500;
mu_grid = linspace(10,22,n_grid)';

n = 1;
Dmu1 = 1/(1/sig02 + n/sig2);
mu_hat1 = Dmu1*(mu0/sig02 + n/sig2*ybar);
post1 = normpdf(mu_grid,mu_hat1,sqrt(Dmu1));

n = 10;
Dmu2 = 1/(1/sig02 + n/sig2);
mu_hat2 = Dmu2*(mu0/sig02 + n/sig2*ybar);
post2 = normpdf(mu_grid,mu_hat2,sqrt(Dmu2));

subplot(1,2,1);
plot(mu_grid,post1,'linewidth',1); box off; xlim([10 22]);

subplot(1,2,2);
plot(mu_grid,post2,'linewidth',1); box off; xlim([10 22]);
set(gcf,'Position',[100 100 800 300])  %% 1 by 2 graphs

% Monte Carlo integration
R = 10000;
mu_hat = 19.09; Dmu = .09;
mu = mu_hat + sqrt(Dmu)*randn(R,1);
g_hat = mean(log(abs(mu)));
