nsim = 10000; burnin = 1000;
N = 100; mu = 3; sig2 = .1;
y = mu + sqrt(sig2)*randn(N,1);

% prior
mu0 = 0; sig20 = 100;
nu0 = 3; S0 = .5;

% initialize the Markov chain
mu = 0; sig2 = 1;
store_theta = zeros(nsim,2);

for isim = 1:nsim + burnin
    % sample mu
    Dmu = 1/(1/sig20 + N/sig2);
    mu_hat = Dmu*(mu0/sig20 + sum(y)/sig2);
    mu = mu_hat + sqrt(Dmu)*randn;
    
    % sample sig2
    sig2 = 1/gamrnd(nu0+N/2,1/(S0+sum((y-mu).^2)/2));

    if isim > burnin
        isave = isim - burnin;
        % store the parameters
        store_theta(isave,:) = [mu sig2];   
    end
    
end
theta_hat = mean(store_theta)';


