function [psi,flag] = sample_psi(psi,e,sig2)
fpsi = @(x) -llike_MA1(x,e,sig2);
psi_hat = fminbnd(fpsi,-1,1);  % the mode
    % compute the negative Hessian 
Del = .01;  % step size
f_1 = llike_MA1(psi_hat+Del,e,sig2);
f_0 = llike_MA1(psi_hat,e,sig2);
f_n1 = llike_MA1(psi_hat-Del,e,sig2);
d2f_psi = (f_n1 - 2*f_0 + f_1)/Del^2;
Dpsi = -1/d2f_psi;
if Dpsi < 0
    Dpsi = .25;
end
psic = psi_hat + chol(Dpsi,'lower')*randn; 
if abs(psic) < .99
    lg = @(x) -.5*(x-psi_hat)'*(Dpsi\(x-psi_hat)); 
    alpMH = llike_MA1(psic,e,sig2) - llike_MA1(psi,e,sig2) ...
        + lg(psi) - lg(psic); 
else
    alpMH = -inf;
end
flag = alpMH > log(rand);
if flag
    psi = psic;
end 
end